﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;
using System.Windows.Media.Animation;
using System.Windows;

namespace xamLinearGauge_barmarkers
{
    public class MainWindowViewModel : DependencyObject
    {
        #region CurrentValue
        public double CurrentValue
        {
            get { return (double)GetValue(CurrentValueProperty); }
            set { SetValue(CurrentValueProperty, value); }
        }

        // Using a DependencyProperty as the backing store for CurrentValue.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty CurrentValueProperty =
            DependencyProperty.Register("CurrentValue", typeof(double), typeof(MainWindowViewModel), new UIPropertyMetadata(0.0));
        #endregion

        /// <summary>
        /// Storyboard for animating the CurrentValue property to the desired value.
        /// </summary>
        Storyboard _currentValueStoryboard;

        /// <summary>
        /// Give the current value a new target to animate to.
        /// </summary>
        public void SetNewTarget(double value)
        {
            _currentValueStoryboard = new Storyboard();
            Storyboard.SetTarget(_currentValueStoryboard, this);

            DoubleAnimation valueAnimation = new DoubleAnimation();
            valueAnimation.From = CurrentValue;
            valueAnimation.To = value;
            valueAnimation.Duration = new Duration(new TimeSpan(0, 0, 1));
            Storyboard.SetTargetProperty(valueAnimation, new PropertyPath(MainWindowViewModel.CurrentValueProperty));

            _currentValueStoryboard.Children.Add(valueAnimation);
            _currentValueStoryboard.Begin();
        }
    }
}
